package com.gic.haoban.manage.web.controller.haoban;

import org.apache.logging.log4j.LogManager;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import com.gic.api.base.commons.BasePageInfo;
import com.gic.api.base.commons.Page;
import com.gic.api.base.commons.ServiceResponse;
import com.gic.commons.webapi.reponse.RestResponse;
import com.gic.haoban.manage.api.dto.chat.ChatOwnerTotalDTO;
import com.gic.haoban.manage.api.dto.chat.GroupChatPlanLogDTO;
import com.gic.haoban.manage.api.dto.chat.GroupChatPlanOwnerLogDTO;
import com.gic.haoban.manage.api.dto.qdto.chat.GroupChatPlanSearchQDTO;
import com.gic.haoban.manage.api.service.chat.GroupChatPlanApiService;

/**
 * 
* @ClassName: GroupChatPlanController
* @Description: 群群发计划
* @author xugh
* @date 2022年11月26日 上午9:32:56
*
 */
@RestController
@RequestMapping("/chat/plan")
public class GroupChatPlanController {

    private static org.apache.logging.log4j.Logger logger = LogManager.getLogger(GroupChatPlanController.class);

    @Autowired
    private GroupChatPlanApiService groupChatPlanApiService;

    @RequestMapping("total-list")
    public RestResponse<Object> totalList(Long planId, String clerkId, String wxEnterpriseId, String enterpriseId,
            BasePageInfo basePageInfo) {
        GroupChatPlanSearchQDTO qdto = new GroupChatPlanSearchQDTO();
        qdto.setWxEnterpriseId(wxEnterpriseId);
        qdto.setEnterpriseId(enterpriseId);
        qdto.setClerkId(clerkId);
        qdto.setPlanId(planId);
        ServiceResponse<Page<ChatOwnerTotalDTO>> page = this.groupChatPlanApiService.listOwnerLogPageForWxaTotal(qdto,
                basePageInfo);
        return RestResponse.successResult(page.getResult());
    }

    @RequestMapping("owner-list")
    public RestResponse<Object> ownerList(Long planId, String clerkId, String wxEnterpriseId, String enterpriseId,
            BasePageInfo basePageInfo) {
        GroupChatPlanSearchQDTO qdto = new GroupChatPlanSearchQDTO();
        qdto.setWxEnterpriseId(wxEnterpriseId);
        qdto.setEnterpriseId(enterpriseId);
        qdto.setClerkId(clerkId);
        qdto.setPlanId(planId);
        ServiceResponse<Page<GroupChatPlanOwnerLogDTO>> page = this.groupChatPlanApiService.listOwnerLogPageForWxa(qdto,
                basePageInfo);
        return RestResponse.successResult(page.getResult());
    }

    @RequestMapping("reflush-qw-msg")
    public RestResponse<Object> reflush(String wxEnterpriseId, String enterpriseId, Long ownerLogId) {
        this.groupChatPlanApiService.reflushSendInfo(ownerLogId);
        return RestResponse.successResult();
    }

    @RequestMapping("owner-do-list")
    public RestResponse<Object> ownerDoList(Long planId, String clerkId, String wxEnterpriseId, String enterpriseId,
            BasePageInfo basePageInfo) {
        GroupChatPlanSearchQDTO qdto = new GroupChatPlanSearchQDTO();
        qdto.setWxEnterpriseId(wxEnterpriseId);
        qdto.setEnterpriseId(enterpriseId);
        qdto.setClerkId(clerkId);
        qdto.setPlanId(planId);
        ServiceResponse<Page<GroupChatPlanLogDTO>> page = this.groupChatPlanApiService.listLogPage(planId, qdto,
                basePageInfo);
        return RestResponse.successResult(page.getResult());
    }

}
